commit fc03893d2fead133ed336511ac00d75c10c5a88d
Author: Jason Merrill <jason@redhat.com>
Date:   Fri Mar 17 09:43:48 2023 -0400

    c++: namespace-scoped friend in local class [PR69410]
    
    do_friend was only considering class-qualified identifiers for the
    qualified-id case, but we also need to skip local scope when there's an
    explicit namespace scope.
    
            PR c++/69410
    
    gcc/cp/ChangeLog:
    
            * friend.c (do_friend): Handle namespace as scope argument.
            * decl.c (grokdeclarator): Pass down in_namespace.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/lookup/friend24.C: New test.

diff --git a/gcc/cp/decl.c b/gcc/cp/decl.c
index 6af7a97a7b9..4c7174395b6 100644
--- a/gcc/cp/decl.c
+++ b/gcc/cp/decl.c
@@ -13467,7 +13467,8 @@ grokdeclarator (const cp_declarator *declarator,
 		      return error_mark_node;
 		  }
 
-		decl = do_friend (ctype, unqualified_id, decl,
+		tree scope = ctype ? ctype : in_namespace;
+		decl = do_friend (scope, unqualified_id, decl,
 				  *attrlist, flags,
 				  funcdef_flag);
 		return decl;
diff --git a/gcc/cp/friend.c b/gcc/cp/friend.c
index fa20a9377a7..e6e2639be4a 100644
--- a/gcc/cp/friend.c
+++ b/gcc/cp/friend.c
@@ -467,19 +467,32 @@ make_friend_class (tree type, tree friend_type, bool complain)
 }
 
 /* Record DECL (a FUNCTION_DECL) as a friend of the
-   CURRENT_CLASS_TYPE.  If DECL is a member function, CTYPE is the
+   CURRENT_CLASS_TYPE.  If DECL is a member function, SCOPE is the
    class of which it is a member, as named in the friend declaration.
+   If the friend declaration was explicitly namespace-qualified, SCOPE
+   is that namespace.
    DECLARATOR is the name of the friend.  FUNCDEF_FLAG is true if the
    friend declaration is a definition of the function.  FLAGS is as
    for grokclass fn.  */
 
 tree
-do_friend (tree ctype, tree declarator, tree decl,
+do_friend (tree scope, tree declarator, tree decl,
 	   tree attrlist, enum overload_flags flags,
 	   bool funcdef_flag)
 {
   gcc_assert (TREE_CODE (decl) == FUNCTION_DECL);
-  gcc_assert (!ctype || MAYBE_CLASS_TYPE_P (ctype));
+
+  tree ctype = NULL_TREE;
+  tree in_namespace = NULL_TREE;
+  if (!scope)
+    ;
+  else if (MAYBE_CLASS_TYPE_P (scope))
+    ctype = scope;
+  else
+    {
+      gcc_checking_assert (TREE_CODE (scope) == NAMESPACE_DECL);
+      in_namespace = scope;
+    }
 
   /* Every decl that gets here is a friend of something.  */
   DECL_FRIEND_P (decl) = 1;
@@ -612,7 +625,7 @@ do_friend (tree ctype, tree declarator, tree decl,
 	       parameters.  Instead, we call pushdecl when the class
 	       is instantiated.  */
 	    decl = push_template_decl_real (decl, /*is_friend=*/true);
-	  else if (current_function_decl)
+	  else if (current_function_decl && !in_namespace)
 	    /* pushdecl will check there's a local decl already.  */
 	    decl = pushdecl (decl, /*is_friend=*/true);
 	  else
diff --git a/gcc/testsuite/g++.dg/lookup/friend24.C b/gcc/testsuite/g++.dg/lookup/friend24.C
new file mode 100644
index 00000000000..9a45410d2a7
--- /dev/null
+++ b/gcc/testsuite/g++.dg/lookup/friend24.C
@@ -0,0 +1,9 @@
+// PR c++/69410
+
+void a();
+void f() {
+    class A {
+        friend void ::a();
+        friend class Z;
+    };
+}

